import random

class Greetings:
    def __init__(self, server):
        self.server = server
        self.join_messages = ["Welcome %s!", "Beware! %s has arrived!", "A wild %s appears.", "%s has come and is ready to pwn."]
        self.left_messages = ["%s has left.", "%s has stopped Giants and started playing Apex. Shame!", "A wild %s disappeared.", "%s was happy with the score and left the game."]

    async def on_player_join(self, player):
        await self.server.broadcast_message(random.choice(self.join_messages) % player.name)

    async def on_map_change(self, newmap):
        await self.server.broadcast_message("You are now playing on "+newmap.mapname)

    async def on_player_change_team(self, player, newteam):
        await self.server.broadcast_message("%s switched to team %s" % (player.name, newteam))

    async def on_player_left(self, player):
        await self.server.broadcast_message(random.choice(self.left_messages) % player.name)


def setup(server):
    plugin = Greetings(server)
    server.add_plugin(plugin)
